"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ava_1 = require("ava");
var path_1 = require("path");
var schema = require('../schema.json');
var _1 = require("../../");
var CONFIG_DIR = path_1.join(__dirname, 'config');
var config;
ava_1.default.beforeEach(function () {
    config = _1.getGraphQLConfig(CONFIG_DIR);
});
ava_1.default('returns a correct name', function (t) {
    var testWithSchemaConfig = config.getProjectConfig('testWithSchema');
    t.deepEqual(testWithSchemaConfig.projectName, 'testWithSchema');
});
ava_1.default('returns a correct root dir', function (t) { return t.deepEqual(config.configDir, CONFIG_DIR); });
ava_1.default('returns a correct schema path', function (t) {
    t.deepEqual(config.getProjectConfig('testWithSchema').schemaPath, path_1.join(CONFIG_DIR, '__schema__/StarWarsSchema.graphql'));
    t.deepEqual(config.getProjectConfig('testWithoutSchema').schemaPath, null);
});
